## ros-foxy-maliput-osm 0.2.2

=== CMakeLists.txt ===
##############################################################################
# Project
##############################################################################

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(maliput_osm LANGUAGES C CXX VERSION 3.0.0)

##############################################################################
# Find 3rd Party Packages
##############################################################################

message(STATUS "\n\n====== Finding 3rd Party Packages ======\n")

find_package(ament_cmake REQUIRED)
find_package(maliput REQUIRED)
find_package(maliput_sparse REQUIRED)
find_package(lanelet2_io REQUIRED)

##############################################################################
# Project Configuration
##############################################################################

message(STATUS "\n\n========= Project Configuration ========\n")

set(BUILD_SHARED_LIBS true)

include(${PROJECT_SOURCE_DIR}/cmake/DefaultCFlags.cmake)
include(${PROJECT_SOURCE_DIR}/cmake/SanitizersConfig.cmake)

ament_environment_hooks(
  "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}"
)

##############################################################################
# Docs
##############################################################################

if(BUILD_DOCS)
  message(STATUS "Doxygen generation - Enabled")
  find_package(ament_cmake_doxygen REQUIRED)
    ament_doxygen_generate(doxygen_maliput_osm
      CONFIG_OVERLAY doc/Doxyfile.overlay.in
      TEST_ON_WARNS
    )
  add_definitions(-DBUILD_DOCS)
else()
  message(STATUS "Doxygen generation - Disabled")
endif()

##############################################################################
# Sources
##############################################################################
add_subdirectory(src)

##############################################################################
# Tests
##############################################################################

if(BUILD_TESTING)
  find_package(ament_cmake_clang_format REQUIRED)
  enable_testing()
  add_subdirectory(test)
  ament_clang_format(CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/.clang-format)
endif()

##############################################################################
# Export
##############################################################################

install(
  DIRECTORY include/
  DESTINATION include
)

install (DIRECTORY resources
         DESTINATION share/${PROJECT_NAME})


ament_environment_hooks("${CMAKE_CURRENT_SOURCE_DIR}/env-hooks/${PROJECT_NAME}.dsv.in")
ament_environment_hooks("${CMAKE_CURRENT_SOURCE_DIR}/env-hooks/${PROJECT_NAME}.sh.in")

ament_export_include_directories(include)
ament_export_dependencies(ament_cmake)
ament_export_targets(${PROJECT_NAME}-targets HAS_LIBRARY_TARGET)

ament_package()

=== src/CMakeLists.txt ===
add_subdirectory(maliput_osm)
add_subdirectory(plugin)
add_subdirectory(test_utilities)
add_subdirectory(utilities)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)
find_package(ament_cmake_gmock REQUIRED)

macro(add_dependencies_to_test target)
if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${PROJECT_SOURCE_DIR}/include
          ${PROJECT_SOURCE_DIR}/src
          ${PROJECT_SOURCE_DIR}/test
      )

      target_link_libraries(${target}
        lanelet2_io::lanelet2_io
        maliput::api
        maliput::common
        maliput::plugin
        maliput::test_utilities
        maliput_osm::builder
        maliput_osm::osm
        maliput_osm::osm_utilities
        maliput_osm::utilities
        maliput_osm::test_utilities
        maliput_sparse::builder
        maliput_sparse::geometry
        maliput_sparse::parser
      )

    endif()
endmacro()

add_subdirectory(builder)
add_subdirectory(osm)
add_subdirectory(plugin)

=== src/maliput_osm/CMakeLists.txt ===
add_subdirectory(builder)
add_subdirectory(osm)

=== src/plugin/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

add_library(road_network road_network.cc)
add_library(maliput_osm::road_network ALIAS road_network)

set_target_properties(road_network
  PROPERTIES
    OUTPUT_NAME maliput_osm_road_network
)

target_link_libraries(road_network
  maliput::api
  maliput::plugin
  maliput_osm::builder
)

target_include_directories(road_network
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

##############################################################################
# Export
##############################################################################

# Using a different location as this target is a dynamic library
# which will be loaded at runtime as a maliput plugin.
set(PLUGIN_INSTALL_DIR
    lib/maliput_plugins
)

install(
  TARGETS road_network
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR}
  RUNTIME DESTINATION bin
)

=== src/test_utilities/CMakeLists.txt ===
##############################################################################
# osm
##############################################################################
if(BUILD_TESTING)

add_library(test_utilities
  osm_types_compare.cc
  builder_configuration_for_osm.cc
)

add_library(maliput_osm::test_utilities ALIAS test_utilities)
set_target_properties(test_utilities
  PROPERTIES
    OUTPUT_NAME maliput_osm_test_utilities
)

target_include_directories(
  test_utilities
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_link_libraries(test_utilities
   PRIVATE
    maliput::test_utilities
    maliput_osm::osm
    maliput_osm::utilities
    maliput_sparse::geometry
    maliput_sparse::parser
    maliput_sparse::test_utilities
)

install(TARGETS test_utilities
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

endif()

=== src/utilities/CMakeLists.txt ===
##############################################################################
# osm
##############################################################################
add_library(utilities
  utilities.cc
)
add_library(maliput_osm::utilities ALIAS utilities)
set_target_properties(utilities
  PROPERTIES
    OUTPUT_NAME maliput_osm_utilities
)

target_include_directories(
  utilities
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_link_libraries(utilities
   PRIVATE
    maliput::common
)

install(TARGETS utilities
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== test/builder/CMakeLists.txt ===
ament_add_gtest(road_geometry_builder_test road_geometry_builder_test.cc)
ament_add_gtest(road_network_builder_test road_network_builder_test.cc)

add_dependencies_to_test(road_geometry_builder_test)
add_dependencies_to_test(road_network_builder_test)

=== test/osm/CMakeLists.txt ===
add_subdirectory(utilities)

ament_add_gtest(conversions_test conversions_test.cc)
ament_add_gtest(osm_manager_test osm_manager_test.cc)

add_dependencies_to_test(conversions_test)
add_dependencies_to_test(osm_manager_test)

=== test/plugin/CMakeLists.txt ===
ament_add_gtest(road_network_plugin_test road_network_plugin_test.cc)

add_dependencies_to_test(road_network_plugin_test)

=== src/maliput_osm/builder/CMakeLists.txt ===
##############################################################################
# osm
##############################################################################
add_library(builder
  builder_configuration.cc
  road_network_builder.cc
)

add_library(maliput_osm::builder ALIAS builder)
set_target_properties(builder
  PROPERTIES
    OUTPUT_NAME maliput_osm_builder
)

target_include_directories(
  builder
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_link_libraries(builder
  PUBLIC
    maliput::api
    maliput::base
    maliput::geometry_base
    maliput_sparse::loader
  PRIVATE
    maliput_sparse::builder
    maliput_sparse::geometry
    maliput_osm::osm
)

install(TARGETS builder
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== src/maliput_osm/osm/CMakeLists.txt ===
##############################################################################
# osm
##############################################################################
add_library(osm
  conversions.cc
  osm_manager.cc
)
add_library(maliput_osm::osm ALIAS osm)
set_target_properties(osm
  PROPERTIES
    OUTPUT_NAME maliput_osm_osm
)

target_include_directories(
  osm
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_link_libraries(osm
   PRIVATE
    lanelet2_core::lanelet2_core
    lanelet2_io::lanelet2_io
    maliput::api
    maliput::common
    maliput_sparse::geometry
    maliput_sparse::parser
)

install(TARGETS osm
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== debian/changelog ===
ros-foxy-maliput-osm (0.2.2-1focal) focal; urgency=high

  * Adds Town01 map. (#52 <https://github.com/maliput/maliput_osm/issues/52>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Thu, 13 Apr 2023 03:00:00 -0000

ros-foxy-maliput-osm (0.2.1-1focal) focal; urgency=high

  * Matches with changes in maliput_sparse. (#51 <https://github.com/maliput/maliput_osm/issues/51>)
  * Standardize parameters' documentation for the builder. (#50 <https://github.com/maliput/maliput_osm/issues/50>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Sun, 08 Jan 2023 03:00:00 -0000

ros-foxy-maliput-osm (0.2.0-1focal) focal; urgency=high

  * Consumes RoadNetworkLoader from maliput_sparse. (#30 <https://github.com/maliput/maliput_osm/issues/30>)
  * Use SPDX identifier in license tag. (#48 <https://github.com/maliput/maliput_osm/issues/48>)
    This updates the license tag to use the SPDX identifier for the 3 clause BSD license: https://opensource.org/licenses/BSD-3-Clause
  * Contributors: Franco Cipollone, Steven! Ragnarök

 -- Daniel Stonier <daniel.stonier@tri.global>  Tue, 13 Dec 2022 03:00:00 -0000

ros-foxy-maliput-osm (0.1.0-1focal) focal; urgency=high

  * Uses default providers offered by maliput base. (#47 <https://github.com/maliput/maliput_osm/issues/47>)
  * Provides default parameters for the road network loader. (#46 <https://github.com/maliput/maliput_osm/issues/46>)
  * Improves documentation. (#45 <https://github.com/maliput/maliput_osm/issues/45>)
  * Adds circuit.osm map. (#44 <https://github.com/maliput/maliput_osm/issues/44>)
  * Adds t_shape_road.osm map. (#43 <https://github.com/maliput/maliput_osm/issues/43>)
  * Supports multiple segments per junction when correspond (#42 <https://github.com/maliput/maliput_osm/issues/42>)
  * Fixes bug on connections (#41 <https://github.com/maliput/maliput_osm/issues/41>)
  * Adds y_shape_road.osm map. (#39 <https://github.com/maliput/maliput_osm/issues/39>)
  * Build branchpoints. (#33 <https://github.com/maliput/maliput_osm/issues/33>)
  * Support loading yaml files for populating RoadNetwork's books. (#35 <https://github.com/maliput/maliput_osm/issues/35>)
  * Adds loop_road_pedestrian_crosswalk map with yaml files. (#34 <https://github.com/maliput/maliput_osm/issues/34>)
  * Parses connections from osm map. (#32 <https://github.com/maliput/maliput_osm/issues/32>)
  * Adds l_shape_road map. (#31 <https://github.com/maliput/maliput_osm/issues/31>)
  * Supports multiple lanes per segment. (#28 <https://github.com/maliput/maliput_osm/issues/28>)
  * Adds c_shape_superelevated_road.osm. (#29 <https://github.com/maliput/maliput_osm/issues/29>)
  * Parses adjacent lane information from osm maps. (#27 <https://github.com/maliput/maliput_osm/issues/27>)
  * Adds multi_lanes_road map. (#25 <https://github.com/maliput/maliput_osm/issues/25>)
  * Adds elevated_arc_lane map. (#23 <https://github.com/maliput/maliput_osm/issues/23>)
  * Adds missing ament macro for exporting targets. (#20 <https://github.com/maliput/maliput_osm/issues/20>)
  * Matches with branchpoint builder implementation. (#24 <https://github.com/maliput/maliput_osm/issues/24>)
  * Adds arc_lane and arc_lane_dense maps. (#19 <https://github.com/maliput/maliput_osm/issues/19>)
  * Adds RoadNetwork plugin. (#15 <https://github.com/maliput/maliput_osm/issues/15>)
  * Adds RoadNetworkBuilder. (#14 <https://github.com/maliput/maliput_osm/issues/14>)
  * Adds RoadGeometryBuilder. (#13 <https://github.com/maliput/maliput_osm/issues/13>)
  * Adds OSMManager (#7 <https://github.com/maliput/maliput_osm/issues/7>)
    * Add straight_forward.osm map
  * Fixes triage workflow. (#17 <https://github.com/maliput/maliput_osm/issues/17>)
  * Implements osm::Lane and osm::Segment classes. (#5 <https://github.com/maliput/maliput_osm/issues/5>)
  * Base configuration of the package/repository. (#4 <https://github.com/maliput/maliput_osm/issues/4>)
  * Initial commit
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Tue, 29 Nov 2022 03:00:00 -0000

=== debian/control ===
Source: ros-foxy-maliput-osm
Section: misc
Priority: optional
Maintainer: Daniel Stonier <daniel.stonier@tri.global>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-clang-format <!nocheck>, ros-foxy-ament-cmake-gmock <!nocheck>, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-lanelet2-io, ros-foxy-maliput, ros-foxy-maliput-sparse, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-maliput-osm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-lanelet2-io, ros-foxy-maliput, ros-foxy-maliput-sparse, ros-foxy-ros-workspace
Description: Maliput backend for loading lanelet2-based osm maps.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-maliput-osm//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
